unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient,
  IdExplicitTLSClientServerBase,
  IdFTP, StdCtrls, {MPlayer,} ExtCtrls, Tabs,
  ComCtrls, IniFiles, ToolWin,
  ActnMan, ActnCtrls, ActnMenus,
  // XPStyleActnCtrls,
  ActnList, {XPMan,}
  MMSystem, StdActns, Menus, FtpSession;


type
//  TFtpSession = record
//    ItemName    : string;
//    UserName    : string;
//    PassWord    : string;
//    Server      : string;
//    UploadPath  : string;
//    EncodedName : string;
//    WaveName    : string;
//  end;

  // application state
  TAppState = (
    stateActiveWaiting,
    stateActiveRecording,
    stateActiveRecordDone,
    stateActiveEncoding,
    stateActiveFTPConnecting,
    stateActiveFTPChDir,
    stateActiveFTPPrepared,
    stateActiveFTPUploading,
    stateActiveFTPDisconnecting,
    stateInactiveIdle,
    stateInactivePlaying
    );

  // recording mode
  TRecMode = ( recHigh, recMiddle, recLow );

  // action mode
  TActionMode = ( actRecOnly, actRecEnc, actRecEncUpload );

  TForm1 = class(TForm)
    IdFTP1: TIdFTP;
    Timer1: TTimer;
    P1ActiveCheckBox: TCheckBox;
    P1StartTimeEdit: TLabeledEdit;
    P1LenHourEdit: TLabeledEdit;
    P1StartDateEdit: TLabeledEdit;
    P1NameEdit: TLabeledEdit;
    P1SelectButton: TButton;
    P1ServerEdit: TLabeledEdit;
    P2ActiveCheckBox: TCheckBox;
    P2StartTimeEdit: TEdit;
    P2LenHourEdit: TEdit;
    P2NameEdit: TEdit;
    P2ServerEdit: TEdit;
    P2SelectButton: TButton;
    P2StartDateEdit: TEdit;
    DetailGroupBox: TGroupBox;
    File1DateEdit: TEdit;
    StaticText1: TStaticText;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    File1UploadEdit: TEdit;
    File1EncodedEdit: TEdit;
    File1PlayButton: TButton;
    File1RecordEdit: TEdit;
    Label4: TLabel;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit13: TEdit;
    Edit14: TEdit;
    File2PlayButton: TButton;
    P1LenMinEdit: TEdit;
    P2LenMinEdit: TEdit;
    ScrollBar1: TScrollBar;
    MonitorStartButton: TButton;
    MonitorStopButton: TButton;
    CurrentTimeLabel: TLabel;
    MonitorListGroupBox: TGroupBox;
    AppStateLabel: TLabel;
    NextActionTimeLabel: TLabel;
    FtpStatusLabel: TLabel;
    FtpWorkProgressBar: TProgressBar;
    PlayStopButton: TButton;
    MainMenu1: TMainMenu;
    SkyBuoyMenuItem: TMenuItem;
    Exit1: TMenuItem;
    RecordingMenuItem: TMenuItem;
    RecordingHighItem: TMenuItem;
    RecordingMiddleItem: TMenuItem;
    RecordingLowItem: TMenuItem;
    ActionModeMenuItem: TMenuItem;
    RecOnlyItem: TMenuItem;
    RecEncItem: TMenuItem;
    RecEncUploadItem: TMenuItem;
    ActionModeText: TStaticText;
    Label5: TLabel;
    P1TimerIdEdit: TLabeledEdit;
    P2TimerIdEdit: TEdit;

    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure P1SelectButtonClick(Sender: TObject);
    procedure P2SelectButtonClick(Sender: TObject);
    //procedure Action1Execute(Sender: TObject);
    //procedure ExitExecute(Sender: TObject);
    procedure MCISend(msg : string);
    procedure IdFTP1Status(ASender: TObject;
      const AStatus: TIdStatus;
      const AStatusText: string);
    //
    procedure MMMCINotify(var Msg: TMessage); message MM_MCINOTIFY;
    procedure ServerSettingClick(Sender: TObject);
    procedure MonitorStartButtonClick(Sender: TObject);
    procedure MonitorStopButtonClick(Sender: TObject);
    procedure TimerTask(Sender: TObject);
    procedure IdFTP1Work(ASender: TObject; AWorkMode: TWorkMode;
      AWorkCount: Integer);
    procedure IdFTP1WorkBegin(ASender: TObject; AWorkMode: TWorkMode;
      AWorkCountMax: Integer);
    procedure IdFTP1WorkEnd(ASender: TObject; AWorkMode: TWorkMode);
    procedure File1PlayButtonClick(Sender: TObject);
    procedure PlayStopButtonClick(Sender: TObject);
    procedure P1ServerEditChange(Sender: TObject);
    procedure P1NameEditChange(Sender: TObject);
    procedure RecordingHighClick(Sender: TObject);
    procedure RecordingMiddleClick(Sender: TObject);
    procedure RecordingLowClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure RecOnlyItemClick(Sender: TObject);
    procedure RecEncItemClick(Sender: TObject);
    procedure RecEncUploadItemClick(Sender: TObject);

  private

    procedure StartMonitor;
    procedure StopMonitor;
    procedure ChangeAppState(s : TAppState);

    procedure DoRecord;
    procedure DoSave;
    procedure DoFTPConnect;
    procedure DoFTPChDir;
    procedure DoFTPUpload;
    procedure DoFTPDisconnect;
    procedure DoPlayStart;
    procedure DoPlayStop;

    procedure SetAppStateLabel(s: string);

    function GetNextStartDateTime : TDateTime;
    function GetNextEndDateTime : TDateTime;
    procedure CheckRecordStart;
    procedure CheckRecordEnd;
    procedure DoEncode;
    procedure DisableTimer;
    procedure EnableTimer;
    procedure DoSelectP1;

    // function GetCurrFtpSession : TFtpSession;
    procedure SetRecordHigh;
    procedure SetRecordMiddle;
    procedure SetRecordLow;
    procedure SetActionRecOnly;
    procedure SetActionRecEnc;
    procedure SetActionRecEncUpload;
    function MakeEncodedName: string;

  public
    { Public 錾 }

  published
//    property CurrFtpSession : TFtpSession
//      read GetCurrFtpSession;
    //
    procedure LoadSettings;
    procedure SaveSettings;

  end;

var
  Form1: TForm1;
  IniFile: TMemIniFile;
  AppState : TAppState;
  Channels : integer;
  SamplesPerSec : integer;
  //
  RecMode : TRecMode;
  ActionMode : TActionMode;
  RecBeginMargin : TDateTime; // ^Jn}[W
  RecEndMargin : TDateTime; // ^I}[W
  //
  FCurrFtpSession : TFtpSession;

implementation

{$R *.dfm}

uses
  ServerSetting, Utility, IdReplyRFC;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.Caption := 'SkyBuoy Ver.0.0.9 (071223)';
  FCurrFtpSession := TFtpSession.Create;
  LoadSettings;
  MonitorStopButton.Enabled := false;
  //
  StopMonitor;
  DoSelectP1;
  //
  case RecMode of
    recLow: SetRecordLow;
    recMiddle: SetRecordMiddle;
    recHigh: SetRecordHigh;
  end;
  //
  RecBeginMargin := EncodeTime(0, 0, 10, 0); // 10sec
  RecEndMargin   := EncodeTime(0, 0, 10, 0); // 10sec;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //
  SaveSettings;
  IniFile.Free;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  //
end;

procedure TForm1.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  //
end;


//function TForm1.GetCurrFtpSession : TFtpSession;
//begin
//  Result := FCurrFtpSession;
//end;

procedure TForm1.SetRecordHigh;
begin
  //
  RecordingHighItem.Checked   := true;
  RecordingMiddleItem.Checked := false;
  RecordingLowItem.Checked    := false;
  //
  Channels := 2;
  SamplesPerSec := 44100;
  RecMode := recHigh;
  //
end;

procedure TForm1.SetRecordMiddle;
begin
  //
  RecordingHighItem.Checked   := false;
  RecordingMiddleItem.Checked := true;
  RecordingLowItem.Checked    := false;
  //
  Channels := 2;
  SamplesPerSec := 22050;
  RecMode := recMiddle;
  //
end;

procedure TForm1.SetRecordLow;
begin
  //
  RecordingHighItem.Checked   := false;
  RecordingMiddleItem.Checked := false;
  RecordingLowItem.Checked    := true;
  //
  Channels := 1;
  SamplesPerSec := 11025;
  RecMode := recLow;
  //
end;

procedure TForm1.SetActionRecOnly;
begin
  ActionMode := actRecOnly;
  RecOnlyItem.Checked := True;
  RecEncItem.Checked := False;
  RecEncUploadItem.Checked := False;
  ActionModeText.Caption := 'Action: ' + RecOnlyItem.Caption;
end;

procedure TForm1.SetActionRecEnc;
begin
  ActionMode := actRecEnc;
  RecOnlyItem.Checked := False;
  RecEncItem.Checked := True;
  RecEncUploadItem.Checked := False;
  ActionModeText.Caption := 'Action: ' + RecEncItem.Caption;
end;

procedure TForm1.SetActionRecEncUpload;
begin
  ActionMode := actRecEncUpload;
  RecOnlyItem.Checked := False;
  RecEncItem.Checked := False;
  RecEncUploadItem.Checked := True;
  ActionModeText.Caption := 'Action: ' + RecEncUploadItem.Caption;
end;


procedure TForm1.ChangeAppState(s : TAppState);
begin
  AppState := s;
  case AppState of
    stateActiveWaiting: begin
      SetAppStateLabel('Active  : Waiting');
    end;
    stateActiveRecording: begin
      SetAppStateLabel('Active  : Recording');
    end;
    stateActiveRecordDone: begin
      SetAppStateLabel('Active  : RecordDone');
    end;
    stateActiveEncoding: begin
      SetAppStateLabel('Active  : Encoding');
    end;
    stateActiveFTPConnecting: begin
      SetAppStateLabel('Active  : FTPConnecting');
    end;
    stateActiveFTPChDir: begin
      SetAppStateLabel('Active  : FTPChDir');
    end;
    stateActiveFTPPrepared: begin
      SetAppStateLabel('Active  : FTPPrepared');
    end;
    stateActiveFTPUploading: begin
      SetAppStateLabel('Active  : FTPUploading');
    end;
    stateActiveFTPDisconnecting: begin
      SetAppStateLabel('Active  : FTPDisconnecting');
    end;
    stateInactiveIdle: begin
      SetAppStateLabel('Inactive: Idle');
    end;
    stateInactivePlaying: begin
      SetAppStateLabel('Inactive: Playing');
    end;
  end;
end;


procedure TForm1.StartMonitor;
begin
  //
  ChangeAppState(stateActiveWaiting);
  MonitorListGroupBox.Enabled := false;
  MonitorListGroupBox.Caption := 'Monitoring Post (running)';
  MonitorStartButton.Enabled := false;
  MonitorStopButton.Enabled := true;
end;

procedure TForm1.StopMonitor;
begin
  //
  ChangeAppState(StateInactiveIdle);
  MonitorListGroupBox.Enabled := true;
  MonitorListGroupBox.Caption := 'Monitoring Post (editable)';
  MonitorStartButton.Enabled := true;
  MonitorStopButton.Enabled := false;
end;


procedure TForm1.TimerTask(Sender: TObject);
begin
  //
  CurrentTimeLabel.Caption := 'Clock: '
    + DateTimeToStr(Now);
  //
  case AppState of
    stateActiveWaiting: begin
      CheckRecordStart;
    end;
    stateActiveRecording: begin
      CheckRecordEnd;
    end;
    stateActiveRecordDone: begin
      DoEncode;
    end;
    stateActiveEncoding: begin
      // wait
    end;
    stateActiveFTPConnecting: begin
      DoFTPConnect;
    end;
    stateActiveFTPChDir: begin
      DoFTPChDir;
    end;
    stateActiveFTPPrepared: begin
      DoFTPUpload;
    end;
    stateActiveFTPUploading: begin
      // wait
    end;
    stateActiveFTPDisconnecting: begin
      DoFTPDisconnect;
    end;
    stateInactiveIdle: begin
      //
    end;
    stateInactivePlaying: begin
      //
    end;
  end;
end;

procedure TForm1.MCISend(msg : string);
begin
  //
  mciSendString(pchar(msg), nil, 0, Handle);
end;

procedure TForm1.MMMCINotify(var Msg: TMessage);
begin
  // notify play done.
  if AppState = stateInactivePlaying then begin
    DoPlayStop;
    ChangeAppState(stateInactiveIdle);
    PlayStopButton.Enabled := false;
    File1PlayButton.Enabled := true;
  end;
end;

procedure TForm1.MonitorStartButtonClick(Sender: TObject);
begin
  StartMonitor;
  //MonitorStartButton.Enabled := false;
  //MonitorStopButton.Enabled := true;
end;

procedure TForm1.MonitorStopButtonClick(Sender: TObject);
begin
  // TODO: ^̃LZɑΉ
  // fƂ܂ŃAbv[hł悤ɂH
  StopMonitor;
  //MonitorStartButton.Enabled := true;
  //MonitorStopButton.Enabled := false;
end;

procedure TForm1.P1NameEditChange(Sender: TObject);
begin
  //
  FCurrFtpSession.ItemName := P1NameEdit.Text;
end;

procedure TForm1.P1SelectButtonClick(Sender: TObject);
begin
  Form2.SetFtpSession(FCurrFtpSession);
  Form2.Show;
end;

procedure TForm1.P1ServerEditChange(Sender: TObject);
begin
  //
  FCurrFtpSession.Server := P1ServerEdit.Text;
end;

procedure TForm1.P2SelectButtonClick(Sender: TObject);
begin
  DetailGroupBox.Caption := 'Reports : '
    + IniFile.ReadString('program2','name','p2');
end;

procedure TForm1.PlayStopButtonClick(Sender: TObject);
begin
  if AppState = stateInactivePlaying then begin
    DoPlayStop;
    ChangeAppState(StateInactiveIdle);
    File1PlayButton.Enabled := true;
  end;
end;

procedure TForm1.SaveSettings;
begin
  with IniFile do begin
    case RecMode of
      recLow:    WriteInteger('general', 'RecMode', 1);
      recMiddle: WriteInteger('general', 'RecMode', 2);
      recHigh:   WriteInteger('general', 'RecMode', 3);
    end;
    case ActionMode of
      actRecOnly:      WriteInteger('general', 'ActionMode', 1);
      actRecEnc:       WriteInteger('general', 'ActionMode', 2);
      actRecEncUpload: WriteInteger('general', 'ActionMode', 3);
    end;
    //
    with FCurrFtpSession do begin
      WriteString('program1', 'name',       ItemName);
      WriteString('program1', 'server',     Server);
      WriteString('program1', 'username',   UserName);
      WriteString('program1', 'password',   PassWord);
      WriteString('program1', 'uploadpath', UploadPath);
      //ShowMessage('uploadpath ' + UploadPath);
    end;
  end;
  with IniFile do begin
    //
    // WriteBool('program1', 'active', P1ActiveCheckBox.Checked);
    WriteString('program1', 'startTime', P1StartTimeEdit.Text);
    WriteString('program1', 'lengthHour', P1LenHourEdit.Text);
    WriteString('program1', 'lengthMin', P1LenMinEdit.Text);
    WriteString('program1', 'startDate', P1StartDateEdit.Text);
    //WriteString('program1', 'name', P1NameEdit.Text);
    //WriteString('program1', 'server', P1ServerEdit.Text);
    //
    UpdateFile;
  end;
end;

procedure TForm1.LoadSettings;
var n : integer;
begin
  IniFile := TMemIniFile.Create(
    ChangeFileExt(Application.ExeName, '.ini'));

  //
  with IniFile do begin
    n := ReadInteger('general', 'RecMode', 1);
    case n of
      1: RecMode := recLow;
      2: RecMode := recMiddle;
      3: RecMode := recHigh;
    end;
    //
    n := ReadInteger('general', 'ActionMode', 1);
    case n of
      1: SetActionRecOnly;
      2: SetActionRecEnc;
      3: SetActionRecEncUpload;
    end;
    //
    with FCurrFtpSession do begin
      ItemName    := ReadString('program1', 'name', 'KBS1');
      Server      := ReadString('program1', 'server', 'server');
      UserName    := ReadString('program1', 'username', 'nishi');
      PassWord    := ReadString('program1', 'password', 'nishi');
      UploadPath  := ReadString('program1', 'uploadpath', '/home/nishi/_work/');
      WaveName    := '_record.wav';
      EncodedName := '_default.mp3';
      //
      P1NameEdit.Text   := ItemName;
      P1ServerEdit.Text := Server;
    end;
    //
  end;
  //
  with IniFile do begin
    // program1
    P1StartTimeEdit.Text := ReadString('program1', 'startTime', '0000');
    P1LenHourEdit.Text   := ReadString('program1', 'lengthHour', '0');
    P1LenMinEdit.Text    := ReadString('program1', 'lengthMin', '00');
    P1StartDateEdit.Text := ReadString('program1', 'startDate', '20070101');
  end;
end;


procedure TForm1.RecOnlyItemClick(Sender: TObject);
begin
  SetActionRecOnly;
end;

procedure TForm1.RecEncItemClick(Sender: TObject);
begin
  SetActionRecEnc;
end;

procedure TForm1.RecEncUploadItemClick(Sender: TObject);
begin
  SetActionRecEncUpload;
end;

procedure TForm1.RecordingHighClick(Sender: TObject);
begin
  SetRecordHigh;
end;


procedure TForm1.RecordingMiddleClick(Sender: TObject);
begin
  SetRecordMiddle;
end;

procedure TForm1.RecordingLowClick(Sender: TObject);
begin
  SetRecordLow;
end;

procedure TForm1.ServerSettingClick(Sender: TObject);
begin
  // server setting
  Form2.Show;
end;

procedure TForm1.File1PlayButtonClick(Sender: TObject);
begin
  //
  if AppState = stateInactiveIdle then begin
    PlayStopButton.Enabled := true;
    ChangeAppState(StateInactivePlaying);
    DoPlayStart;
  end;
end;

function TForm1.GetNextStartDateTime : TDateTime;
var
  stime : TDateTime;
  p1str : string;
begin
  try
    p1str := ReformatDate(P1StartDateEdit.Text)
      + ' ' + ReformatTime(P1StartTimeEdit.Text);
    stime := StrToDateTime(p1str); // '2007/08/23 11:24:00'
  except on Exception do
    stime := 0;
  end;
  Result := GetComingDateTime(stime - RecBeginMargin);
end;

function TForm1.GetNextEndDateTime : TDateTime;
var
  stime, etime : TDateTime;
  p1str : string;
  hour, min : integer;
begin
  try
    p1str := ReformatDate(P1StartDateEdit.Text)
      + ' ' + ReformatTime(P1StartTimeEdit.Text);
    stime := StrToDateTime(p1str); // '2007/08/23 11:24:00'
    hour := SafeStrToInt(P1LenHourEdit.Text);
    min  := SafeStrToInt(P1LenMinEdit.Text);
    etime := stime + EncodeTime(hour, min, 0, 0); // hour, min, sec, msec
  except on Exception do
    etime := 0;
  end;
  Result := GetComingDateTime(etime + RecEndMargin);
end;

procedure TForm1.CheckRecordStart;
var
  s, e : TDateTime;
begin
  s := GetNextStartDateTime;
  e := GetNextEndDateTime;
  if (s <> 0) and (e <> 0) then begin
    NextActionTimeLabel.Caption :=
      'Start: ' + DateTimeToStr(s);
    if (s < Now) and (Now < e) then begin
      DoRecord;
    end;
  end;
end;

procedure TForm1.CheckRecordEnd;
var
  d : TDateTime;
begin
  d := GetNextEndDateTime;
  if (d <> 0) then begin
    NextActionTimeLabel.Caption :=
      'End: ' + DateTimeToStr(d);
    if (d < Now) then begin
      DoSave;
    end;
  end;
end;

function TForm1.MakeEncodedName : string;
begin
  Result :=
    // year month day hour min
    FormatDateTime('yymmdd-hhnn', Now + RecBeginMargin)
    + '-'
    + P1NameEdit.Text
    + '.mp3';
end;

procedure TForm1.DoRecord;
begin
  DisableTimer;
  //foCXI[v
  mciSend('OPEN NEW TYPE WAVEAUDIO ALIAS WAVEFILE');
  //WavetH[}bg
  mciSend('SET WAVEFILE '
    + 'FORMAT TAG PCM '
    + 'TIME FORMAT milliseconds '
    + 'ALIGNMENT ' + IntToStr(2 * Channels) + ' ' // bytesPerSample * channels
    + 'BITSPERSAMPLE 16 '
    + 'CHANNELS ' + IntToStr(Channels) + ' '
    + 'SAMPLESPERSEC ' + IntToStr(SamplesPerSec) + ' '
    + 'BYTESPERSEC ' + IntToStr(SamplesPerSec) + ' ');
  //^Jn @
  mciSend('RECORD WAVEFILE');
  //
  FCurrFtpSession.EncodedName := MakeEncodedName;
    // P1NameEdit.Text + '-'
    // + FormatDateTime('mmddhhnn', Now) // month day hour min
    // + '.mp3';
  File1EncodedEdit.Text := FCurrFtpSession.EncodedName;
  //
  File1DateEdit.Text := FormatDateTime('yyyymmdd', Now);
  File1RecordEdit.Text := 'yet';
  File1UploadEdit.Text := 'yet';
  //
  ChangeAppState(stateActiveRecording);
  EnableTimer;
end;

procedure TForm1.DoSave;
begin
  DisableTimer;
  // ^I
  mciSend('STOP WAVEFILE');
  mciSend('SAVE WAVEFILE '
    + '"' + TempDir + '\'
    + FCurrFtpSession.WaveName // + 'record.wav'
    + '" ');
  mciSend('CLOSE WAVEFILE');
  //
  File1RecordEdit.Text := 'done';
  //
  ChangeAppState(stateActiveRecordDone);
  EnableTimer;
end;

procedure TForm1.DoEncode;
begin
  //
  //CurrFile := P1NameEdit.Text + '-' + '09131155' + '.mp3';
  File1EncodedEdit.Text := FCurrFtpSession.EncodedName;
  File1UploadEdit.Text := 'doing';
  //
  ChangeAppState(stateActiveEncoding);
  // ̊Ԃ TimerTask ͌Ă΂
  ConvertWaveToMP3(
    FCurrFtpSession.WaveName,
    FCurrFtpSession.EncodedName);
  //
  ChangeAppState(stateActiveFTPConnecting);
end;

procedure TForm1.DisableTimer;
begin
  Timer1.Enabled := false;
end;

procedure TForm1.EnableTimer;
begin
  //
  Timer1.Enabled := true;
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.DoSelectP1;
begin
  DetailGroupBox.Caption := 'Reports : '
    + IniFile.ReadString('program1', 'name', 'p1');
  DetailGroupBox.Enabled := true;
end;



procedure TForm1.DoFTPConnect;
begin
  //
  DisableTimer;
  with Idftp1 do
  begin
    Username := FCurrFtpSession.UserName;
    Password := FCurrFtpSession.PassWord;
    try
      Connect(FCurrFtpSession.Server);
    except on EIdReplyRFCError do
      ShowMessage('FTPConnect error')    
      //
    end;
  end;
  ChangeAppState(stateActiveFTPChDir);
  EnableTimer;
end;

procedure TForm1.DoFTPChDir;
begin
  DisableTimer;
  // chdir
  Idftp1.ChangeDir(FCurrFtpSession.UploadPath);
  ChangeAppState(stateActiveFTPPrepared);
  EnableTimer;
end;

procedure TForm1.DoFTPUpload;
begin
  // ftp upload
  // do not disable Timer
  Idftp1.Put(RecordingDir + '\' + FCurrFtpSession.EncodedName);
  ChangeAppState(stateActiveFTPDisconnecting);
end;

procedure TForm1.DoFTPDisconnect;
begin
  DisableTimer;
  // ftp bye
  Idftp1.Disconnect;
  //
  DeleteFile(FCurrFtpSession.WaveName);
  //
  File1UploadEdit.Text := 'done';
  File1PlayButton.Enabled := true;
  //
  ChangeAppState(stateActiveWaiting);
  EnableTimer;
end;

procedure TForm1.DoPlayStart;
begin
  DisableTimer;
  mciSend('open ' +
    '"' + RecordingDir + '\'
    + File1EncodedEdit.Text // + 'record.mp3'
    + '" '
    + 'type Mpegvideo alias mp3');
  mciSend('play mp3 notify');
  EnableTimer;
end;


procedure TForm1.DoPlayStop;
begin
  DisableTimer;
  // play stop
  mciSend('stop mp3');
  mciSend('close mp3');
  EnableTimer;
end;


procedure TForm1.SetAppStateLabel(s : string);
begin
  AppStateLabel.Caption := s;
end;


procedure TForm1.IdFTP1Status(ASender: TObject;
  const AStatus: TIdStatus;
  const AStatusText: string);
begin
  //
  FtpStatusLabel.Caption := AStatusText;
end;

procedure TForm1.IdFTP1Work(ASender: TObject;
  AWorkMode: TWorkMode;
  AWorkCount: Integer);
begin
  //
  FtpWorkProgressBar.Position := AWorkCount;
end;

procedure TForm1.IdFTP1WorkBegin(ASender: TObject;
  AWorkMode: TWorkMode;
  AWorkCountMax: Integer);
begin
  //
  FtpWorkProgressBar.Max := AWorkCountMax;
end;

procedure TForm1.IdFTP1WorkEnd(ASender: TObject;
  AWorkMode: TWorkMode);
begin
  //
  FtpWorkProgressBar.Position := 0;
end;

end.
