unit Utility;

interface

function AppDir : String;
function TempDir : String;
function RecordingDir : String;
function ReformatDate(src: String) : String;
function ReformatTime(src: String) : String;
function SafeStrToInt(src: String) : Integer;
function GetComingDateTime(t: TDateTime) : TDateTime;
procedure ConvertWaveToMP3(
  waveFilename, encodedFilename: string);

implementation

uses
  Windows, Messages, SysUtils, Variants,
  Classes, Graphics, Controls, Forms,
  Dialogs;

// skybuoy.exe ̂ꏊ
function AppDir : String;
begin
  result := ExtractFilePath(Application.ExeName)
end;

// temporary dir
function TempDir : String;
begin
  result := ExtractFilePath(Application.ExeName)
end;

// ^t@Cuꏊ
function RecordingDir : String;
begin
  result := ExtractFilePath(Application.ExeName)
end;

// yyyymmdd -> yyyy/mm/dd
function ReformatDate(src: String) : String;
begin
  if Length(src) = 8 then begin
    Result := src;
    Insert('/', Result, 5);
    Insert('/', Result, 8);
  end
  else begin
    Result := '01/01' // default
  end;
end;

// hhmm -> hh:mm:00
function ReformatTime(src: String) : String;
begin
  //
  if Length(src) = 4 then begin
    Result := src;
    Insert(':', Result, 3);
    Result := Result + ':00';
  end
  else begin
    Result := '00:00:00' // default
  end;
end;

function GetComingDateTime(t: TDateTime) : TDateTime;
var
  n : TDateTime;
begin
  // Int() 𓾂
  // Frac() 𓾂
  Result := t;
  // Now ƔrƁAvꍇ
  // ̓ Result ɂĂ܂
  n := Now - EncodeTime(0,1,0,0); // 1min
  if (t < n) then begin
    // (1) t=9/01  0:01 Now=9/01 10:01 -> Result=9/02  0:01
    // (2) t=9/01 10:01 Now=9/02  0:01 -> Result=9/02 10:01
    if Frac(t) < Frac(n) then begin
      // (1)
      Result := Int(n) + 1 + Frac(t);
    end
    else begin
      // (2)
      Result := Int(n) + Frac(t);
    end;
  end;
end;

//
function SafeStrToInt(src: String) : Integer;
begin
  //  if Length(src) > 0 then begin
  //    Result := StrToInt(src)
  //  end
  //  else begin
  //    Result := 0 // default
  //  end;
  Result := StrToIntDef(src, 0);
end;

// http://homepage2.nifty.com/Mr_XRAY/Delphi/plSamples/T_ConsoleBat2.htm
//=============================================================================
//  w肵t@Cs(Halbowق)
//=============================================================================
function WinExecAndWait(FileName: string): DWORD;
var
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  FillChar(StartupInfo, SizeOf(StartupInfo), #0);
  StartupInfo.cb          := SizeOf(StartupInfo);
  StartupInfo.dwFlags     := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := SW_HIDE;

  if not CreateProcess(nil,
    PChar(FileName),      // pointer to command line string
    nil,                  // pointer to process security attributes
    nil,                  // pointer to thread security attributes
    False,                // handle inheritance flag
    CREATE_NEW_CONSOLE or // creation flags
    NORMAL_PRIORITY_CLASS,
    nil,                  // pointer to new environment block
    nil,                  // pointer to current directory name
    StartupInfo,          // pointer to STARTUPINFO
    ProcessInfo)          // pointer to PROCESS_INF
  then
    Result := WAIT_FAILED
  else begin
    while WaitForSingleObject(ProcessInfo.hProcess,100) = WAIT_TIMEOUT do begin
      Application.ProcessMessages;
    end;
    GetExitCodeProcess(ProcessInfo.hProcess, Result);
    CloseHandle(ProcessInfo.hProcess);
    CloseHandle(ProcessInfo.hThread);
  end;
end; { WinExecAndWait32 }

//
procedure ConvertWaveToMP3(
  waveFileName,
  encodedFilename: string);
var
   BatFullPath : String;
   //OutFullPath : String;
   strlist : TStringList;
begin
   strlist := TStringList.Create;
   BatFullPath := TempDir + '_convert.bat';
   try
     strlist.Add(
      // 'c:\bin\ffmpeg.exe'
      '"' + AppDir + 'ffmpeg.exe' + '"'
      + ' '
      + '-i '
      + '"' + TempDir
      + waveFileName // 'record.wav '
      + '"'
      + ' '
      + '"'
      + RecordingDir
      + encodedFilename // 'record.mp3'
      + '"'
      );
     strlist.Add('EXIT');
     strlist.SaveToFile(BatFullPath);
   finally
     strlist.Free;
   end;
   WinExecAndWait(BatFullPath);
   DeleteFile(BatFullPath);
end;

end.
